    //#New(backend): Y                                                //- [Y]  if new (backend) to add
    //#Init_Base:     Task()                                               //- parameter to add at launch of library in case of backend
    //#Init_Include:                                                 //- function added at initialization (it can be Loop_Base)
    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event
    //#Loop1_Event:                                                  //- event to monitor in a loop
    //#Loop1_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- event to monitor in a loop
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- event to monitor in a loop
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#CallBack1_Base:                                               //- callback on arduino side
    //#CallBack1_Config: SubVoid_StringBArray 0 1 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- callback on arduino side
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- callback on arduino side
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#

#include "B4RDefines.h"  
#include "rScheduler1.h"
     
       void Task1::setup()
       {
          B4R::B4RTask1::setup();
       };  
       void Task1::loop()
       { 
          B4R::B4RTask1::loop();
       };      
       void Task2::setup()
       {
          B4R::B4RTask2::setup();
       };
       void Task2::loop()
       {
          B4R::B4RTask2::loop();
       };  
    
       void Task3::setup()
       {
           B4R::B4RTask3::setup();
       };       
       void Task3::loop()
       {
          B4R::B4RTask3::loop();
     };      

   
namespace B4R
{
    B4RTask1* B4RTask1::instance1 = NULL; 
    B4RTask2* B4RTask2::instance2 = NULL; 
    B4RTask3* B4RTask3::instance3 = NULL; 
    
/****************************************************/       
    void B4RTask1::initialize(SubVoid_Void Setup1CallBackSub, SubVoid_Void Loop1CallBackSub)  
    {  
       rcs1 = new (backend) Task1();
       this->Setup1CallBackSub = Setup1CallBackSub;
       this->Loop1CallBackSub = Loop1CallBackSub;  
       instance1 = this;
    };

    void B4RTask1::setup()
    { 
       instance1->Setup1CallBackSub();
    };

    void B4RTask1::loop()
    { // SchedulerClass Schedul; Schedul.SerialPrint("Task1 Loop lib\n");
       instance1->Loop1CallBackSub(); 
    };
       
    void B4RTask1::delay(uint32_t ms)
    {
       rcs1->delay(ms);
    };

    void B4RTask1::Yield()
    {
      rcs1-> yield();
    };
    
    bool B4RTask1::isDelayed()
    {
       return rcs1->isDelayed();
    };   
    
    void B4RTask1::updateDelayTimer()  
    {
       rcs1->updateDelayTimer();
    };   

    bool B4RTask1::shouldRun()
    {
       return rcs1->shouldRun();
    };



/***************************************************/
    void B4RTask2::initialize(SubVoid_Void Setup2CallBackSub, SubVoid_Void Loop2CallBackSub)  
    {  
       rcs2 = new (backend) Task2();
       this->Setup2CallBackSub = Setup2CallBackSub;
       this->Loop2CallBackSub = Loop2CallBackSub;  
       instance2 = this;
    };

     void B4RTask2::setup()
    { 
       instance2->Setup2CallBackSub();
    };

    void B4RTask2::loop()
    {
       instance2->Loop2CallBackSub(); 
    };   
       
    void B4RTask2::delay(uint32_t ms)
    {
       rcs2->delay(ms);
    };

    void B4RTask2::Yield()
    {
       rcs2->yield();
    };
    
    bool B4RTask2::isDelayed()
    {
       return rcs2->isDelayed();
    };   
    
    void B4RTask2::updateDelayTimer()  
    {
       rcs2->updateDelayTimer();
    };       

    bool B4RTask2::shouldRun()
    {
       return rcs2->shouldRun();
    };


/****************************************************/       
    void B4RTask3::initialize(SubVoid_Void Setup3CallBackSub, SubVoid_Void Loop3CallBackSub)  
    {  
       rcs3 = new (backend) Task3();
       this->Setup3CallBackSub = Setup3CallBackSub;
       this->Loop3CallBackSub = Loop3CallBackSub;  
       instance3 = this;
    };

    void B4RTask3::setup()
    { 
       instance3->Setup3CallBackSub();
    };

    void B4RTask3::loop()
    { 
       instance3->Loop3CallBackSub(); 
    }; 
       
    void B4RTask3::delay(uint32_t ms)
    {
       rcs3->delay(ms);
    };

    void B4RTask3::Yield()
    {
       rcs3->yield();
    };
    
    bool B4RTask3::isDelayed()
    {
       return rcs3->isDelayed();
    };   
    
    void B4RTask3::updateDelayTimer()  
    {
       rcs3->updateDelayTimer();
    };   

    bool B4RTask3::shouldRun()
    {
       return rcs3->shouldRun();
    };



/****************************************************/
    void B4RScheduler1::initialize(byte TaskNb)  
    {  
    
        SchedulerClass Sched;
       if(TaskNb >= 0)  {static Task1 Task_1; Sched.start(&Task_1);Sched.SerialPrintln("TasK1 Start");};

       if(TaskNb >= 1)  {static Task2 Task_2; Sched.start(&Task_2);Sched.SerialPrintln("TasK2 Start");};  

       if(TaskNb >= 2)  {static Task3 Task_3; Sched.start(&Task_3);Sched.SerialPrintln("TasK3 Start");};  

    }
     
    void B4RScheduler1::begin()  
    {  
       Sched.begin();
    }
    
    uint8_t B4RScheduler1::getCurrentRunGroupID()
    {
       return Sched.getCurrentRunGroupID();
    }

    uint8_t B4RScheduler1::getCurrentCycleID()
    {
       return Sched.getCurrentCycleID();
    }

    uint8_t B4RScheduler1::countRunGroups()
    {
       return Sched.countRunGroups();
    }

    void B4RScheduler1::updateRunGroups()
    {
       Sched.updateRunGroups();
    };
    
    void B4RScheduler1::updateCurrentTask()
    {
       Sched.updateCurrentTask();
    }
}