    //#New(backend): Y                                                //- [Y]  if new (backend) to add
    //#Init_Base:     Task()                                               //- parameter to add at launch of library in case of backend
    //#Init_Include:                                                 //- function added at initialization (it can be Loop_Base)
    //#Loop_Base:                                                    //- function launched at loop start and activation callback function on event
    //#Loop1_Event:                                                  //- event to monitor in a loop
    //#Loop1_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop2_Event:                                                  //- event to monitor in a loop
    //#Loop2_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#Loop3_Event:                                                  //- event to monitor in a loop
    //#Loop3_Config: SubVoid_Void  0 DataAvailableSub                //- parameters of callback created: CallbackType EndPar callbacksub
    //#CallBack1_Base:                                               //- callback on arduino side
    //#CallBack1_Config: SubVoid_StringBArray 0 1 MessageArrivedSub          //- CallbackType Par1 EndPar callbacksub
    //#CallBack2_Base:                                               //- callback on arduino side
    //#CallBack2_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#CallBack3_Base:                                               //- callback on arduino side
    //#CallBack3_Config: SubVoid_StringBArray 0 2 NewMessageSub      //- CallbackType Par1 Par2 EndPar callbacksub
    //#

#pragma once
#include "B4RDefines.h"
#include "Scheduler1.h"
#include "Task.h"

    class Task1 : public Task
    { 
      public:
       void setup();
       void loop();
    } ;    
    class Task2 : public Task
    {
      public:
       void setup();
       void loop();
    } ;    
    class Task3 : public Task
    {
       public: 
       void setup();     
       void loop();  
    } ;
       
    //~Event: 
    //~Version: 1.0 
    //~Author - 
    //~Libray from Arduino: https://github.com/nrwiersma/ESP8266Scheduler
namespace B4R {
   typedef void (*SubVoid_Void)(void);
    //~shortname:Task1
    //~Event:  Setup1CallBack();
    //~Event:  Loop1CallBack();
    class B4RTask1   
    {                                           
        private:
            static B4RTask1* instance1;         
            uint8_t backend[sizeof(Task1)];
            Task1* rcs1;
            SubVoid_Void Setup1CallBackSub; 
            SubVoid_Void Loop1CallBackSub;                      
        public: 
            void initialize(SubVoid_Void Setup1CallBackSub, SubVoid_Void Loop1CallBackSub);
            static void setup();
            static void loop();
            void delay(uint32_t ms);
            void Yield();
            bool isDelayed();
            void updateDelayTimer();             
            bool shouldRun();                
    };
    //~shortname:Task2
    //~Event:  Setup2CallBack();
    //~Event:  Loop2CallBack();    
    class B4RTask2
    {
        private:
            static B4RTask2* instance2;            
            uint8_t backend[sizeof(Task2)];
            Task2* rcs2;
            SubVoid_Void Setup2CallBackSub;
            SubVoid_Void Loop2CallBackSub;              
        public: 
            void initialize(SubVoid_Void Setup2CallBackSub, SubVoid_Void Loop2CallBackSub);
            static void setup();
            static void loop();
            void delay(uint32_t ms);
            void Yield();
            bool isDelayed();
            void updateDelayTimer();              
            bool shouldRun(); 
    };
    
   //~shortname:Task3
    //~Event:  Setup3CallBack();
    //~Event:  Loop3CallBack();    
    class B4RTask3
    {
        private:
            static B4RTask3* instance3;            
            uint8_t backend[sizeof(Task3)];
            Task3* rcs3;
            SubVoid_Void Setup3CallBackSub;
            SubVoid_Void Loop3CallBackSub;                
        public: 
            void initialize(SubVoid_Void Setup3CallBackSub, SubVoid_Void Loop3CallBackSub);
            static void setup();
            static void loop();
            void delay(uint32_t ms);
            void Yield();
            bool isDelayed();
            void updateDelayTimer();  
            bool shouldRun();
    };    

    //~shortname:Scheduler1
    class B4RScheduler1
    {
        private:          
//            uint8_t backend[sizeof(SchedulerClass)];
            SchedulerClass  Sched; //* rcs;   
        public: 
        
            void initialize(byte TaskNb);
            uint8_t getCurrentRunGroupID(); 
            uint8_t getCurrentCycleID();
            uint8_t countRunGroups(); 
            void updateRunGroups();
            void updateCurrentTask();
            void begin();
    };
}

